(function(){
	/*============= Native 与 h5 交互 =============*/
	/*
	 * ios WebviewJavascriptBriage
	 * android newslistener / imglistener
	 */
	var SHAREMAPPER = {
		1: "wxtimeline", //"微信朋友圈"
		2: "wxsession", //"微信好友"
		3: "weibo", //"新浪微博"
		4: "qqzone" //"QQ空间"
	}
	var config = {
		icon: location.protocol+"//"+location.host+location.pathname.split("share.html")[0]+"/images/favicon.ico",
		webSite: "http://www.9icaishi.com",
		type: "video/mp4"
	}
	var net = 0; // 网络状态 1 wifi(default) 0 !wifi，用于控制详情页图片加载
	var isFlowSave = 1; // 省流量模式 1 true 0 false(default) ，用于控制详情页图片加载
	var imageList;
	var imgLoadManager;
	var originSubPortrait = defaultOriginSubPortrait = "http://images.9liuda.com/user_default.png";
	var isOriginSub = "0"; // 源是否可订阅
	var originSubOption = {
		"1": {text: "已订阅", css: "ed"},
		"0": {text: "订阅", css: ""},
		"-1": {text: "", css: "hidden"}
	}
	var util = {
		getUrlParam: function(){
		    var search = window.location.search.substr(1);
		    var mappers = search.split("&");
		    var hash = {};
		    for(var i in mappers){
		        var index = mappers[i].indexOf("=");
		        hash[mappers[i].substring(0,index)] = mappers[i].substring(index+1)
		    }
		    return hash;
		},
		getUA: function(){
			var UA = navigator.userAgent.toLowerCase(), plat = null;
			if(UA.match(/iphone|ipad|ipod/)){
				plat = "ios";
			}
			if(UA.match(/android/)){
				plat = "android";
			}
			return plat;
		},
		getFormatTime: function(time){
			var current = (new Date()).getTime();
			var cross = current - time;
			cross = Math.round(cross/1000);
			if(cross < 2){
			    return "刚刚发布";
			}
			if(cross < 60){
			    return cross+"秒前"
			}
			if(cross > 60 && cross < 3600){
			    cross = Math.round(cross/60);
			    return cross+"分钟前"
			}
			if(cross > 3600 && cross < 3600*24){
			    cross = Math.floor(cross/3600);
			    return cross+"小时前"
			}
			if(cross > 3600*24){
			    cross = Math.floor(cross/(3600*24));
			    return cross+"天前"
			}
		},
		findKey: function(arr,hash){
			var key = hash.split("=")[0];
			var val = hash.split("=")[1];
			for(var i = 0; i < arr.length; i++){
				if(arr[i][key] == val){
					return arr[i];
				}
			}
			return {};
		}
	}

	function rebuildContent(data, images, videos){
		try{
			/**
			 * replace image
			 * if !wifi set img-box width = 220px , height = 156px
			 */
			var clientW = document.body.clientWidth;
		        clientW = clientW > 640 ? 640 : clientW;
		        clientW -= 30;
	        var innerH = window.innerHeight;
			data = data.replace(/\${{(\d+)}}\$/g,function(match, num){
		        var image = util.findKey(images,"key="+num);
		        var w = image.width,
		        	h = image.height;
		        if(w > clientW){
		        	h = h*(clientW/w);
		        }
		        h = h > innerH ? innerH : h;
		        var style = "width:"+w+"px;height:"+h+"px";
		        var html = "<span class='img-box imgDefaultSet' data-index=\""+num+"\" data-key=\""+image.key+"\" style="+style+">";
		        	html += "<svg class=\"circular\" viewBox=\"25 25 50 50\"><circle class=\"path\" cx=\"50\" cy=\"50\" r=\"20\" fill=\"none\" stroke-width=\"2\" stroke-miterlimit=\"10\"></circle></svg>";
		        /**
		         * set gifStatus as false no matter the real gifStatus value
		         * in the latest release, when play gif , the platBtn should be clicked
		         */
		        // image.gifStatus = 0;
		        if (image.gifStatus) {
		        	html += "<i class=\"playBtn\"></i>";
		        	html += "<span><img class=\"news-img img-page\" src=\""+image.url+"\"></span>";
		        }else{
		        	//html += "<img class='news-img img-page' src='"+image.src+"'>";
		        }
		        html += "</span>"
		        return html;
		    });
			data = data.replace(/#{{(\d+)}}#/g,function(match, num){
		        var video = util.findKey(videos,"key="+num);
		        var poster = video && video.cover && video.cover.url;
		        var type = video && video.type || config.type;
		        var html = "<span class='video-box' data-index=\""+num+"\" data-key=\""+num+"\">";
		        	html +=		"<i></i>";
		        	html += 	"<video id='video-box-"+num+"' class=\"vjs-default-skin\" poster=\""+poster+"\">";
		        	html += 		"<source src=\""+video.url+"\" type=\""+type+"\"/>";
		        	html += 	"</video>";
		        	html += "</span>";
		        return html;
		    });
		    return data;
		}catch(e){
			console.error(e);
		} 
	}

	function InitImgLoad(images){

		var loadOne = function(i,preLoadImgs,callback){
			var key = preLoadImgs[i]["key"],
				gifStatus = preLoadImgs[i]["gifStatus"],
				box = $(".img-box[data-key='"+key+"']"),
				mode = box.data("mode");
			var img = new Image();
			var url = preLoadImgs[i].url; // 默认 wifi 环境 非gif
			if(gifStatus == 1){
				url = preLoadImgs[i].src;
			}
			if(net == 0){
				if(isFlowSave){
					if(!mode || mode == "small"){
						box.data("mode","small");
						if(!gifStatus){
							box.addClass("small");
							url = preLoadImgs[i].small;
						}
					}else{
						box.hasClass("small") && box.removeClass("small");
					}
				}else{
					
				}
				// 非 wifi 情况下 gif始终加载静态图 等待点击
				if(gifStatus == 1){
					url = preLoadImgs[i].url;
				}
			}

			img.src = url;
			img.class = "news-img img-page";
			img.style.width = "100%";
			img.onload = function(){
				box.removeClass("imgDefaultSet failLoadImg");
				box.off("click");
				box.data("canBig",1);
				if(net == 0 && isFlowSave && (!mode || mode == "small") && !gifStatus){
					box.data("canBig",0);
					box.on("click",function(){
						box.data("mode","big");
						loadOne(i,preLoadImgs,function(){
							that.setPosition();
						});
					})
				}
				if(gifStatus == 1 && net == 0){
					box.find("span").html(this);
				}else{
					box.html(this);
				}
				box.css("height","auto");
				callback && callback();
			}
			img.onerror = function(){
				box.addClass("imgDefaultSet failLoadImg");
				if(box.hasClass("first")){
					box.removeClass("first");
				}
				box.find("img").remove();
				box.on("click",function(){
					box.removeClass("failLoadImg");
					loadOne(i,preLoadImgs);
				});
			}
		}

		var load = function(preLoads){
			var preLoadImgs = [];
			for(var j = 0; j < preLoads.length; j++){
				preLoadImgs.push(imgObjs[preLoads[j]]);
			}
			for(var i = 0; i < preLoadImgs.length; i++){
				loadOne(i,preLoadImgs);
			}
		}

		var scroll = this.scroll = function(scrollTop){
			if(true){
				var sh = typeof scrollTop == "number" ? scrollTop : document.body.scrollTop;
				var ih = screen.height;
				var preLoads = [];
				for(var k = 0; k < imgArrs.length; k++){
					if(imgArrs[k].top < sh + ih && imgArrs[k].top > sh - ih && !imgArrs[k].isLoaded){
						preLoads.push(imgArrs[k].key);
						imgArrs[k].isLoaded = true;
					}
				}
				load(preLoads);
			}
		}
		/**
		 * [initPosition 
		  	初始化 计算并存储 每个图片在dom中的位置，作为滑动加载的参考标准
			小图模式的情况下 每次切换一个小图为大图时 要重新计算每个图片的位置]
		 * @param  {[type]} pos  [ 传入坐标 默认为空 从头开始加载 在阅读网文章退出后再次进入时 传入上次阅读的位置 加载此位置的图片 ]
		 * @param  {[type]} load [ 是否立即加载当前坐标的图片 ]
		 * @return {[type]}      [description]
		 */
		var setPosition = this.setPosition = function() {
			var temp = [];
			for(var j = 0; j < imgBoxs.length; j++){
				var key = $(imgBoxs[j]).data("key");
				imgArrs.push({
					key: key,
					top: imgBoxs[j].offsetTop,
					isLoaded: imgArrs[j] ? imgArrs[j].isLoaded : false
				})
			}
		}
		this.getPosition = function(){
			return imgArrs;
		}
		this.init = function(pos){
			setPosition();
            scroll(pos);
		}
		if(!net){
			$(".content").addClass("notWifi");
		}
		if(isFlowSave){
			$(".content").addClass("flowSave");
		}
		var scrollH = document.body.scrollHeight;
		var imgBoxs = $(".img-box");
		var that = this, imgArrs = [], imgObjs = {};
		
		for(var q = 0; q < images.length; q++){
			imgObjs[images[q].key] = images[q];
		}
		/**
		 * 如果没有图片 exit
		 */
		if(q == 0) return;
		var ua = util.getUA();
		/**
		 * ios onload时执行一次加载，绑定滑动事件，
		 * android 需要通过native 调用 执行首次加载，滑动事件有native监测，并调用scroll 实现图片加载  
		 */
		// if(ua == "ios"){
			this.init();
		// }
		$(window).on("scroll",this.scroll);
		/**
		 * 1 非wifi环境下 切 图片数量大于1 第一张图片前 添加按钮 “显示全部大图”
		 * 2 第一张图片 添加 遮罩层 提示 点击加载大图
		 * 3 第一张图如果是gif 则不添加遮罩层
		 */
		if(net == 0){ //net == 0
			var AllImg = $(".img-box").filter(function(){
				return $("i.playBtn",this).length == 0;
			});
			firstImg = AllImg.first();
			firstImg.addClass("first");
			// 如果图片（去除gif）的数量小于2 则 返回 ，不执行 操作1 （上面注释）
			if(AllImg.length < 2){
				return;
			}
			var btn = $("<button class='btn showBigImg'>全部显示大图</button>");
			firstImg.before(btn);
			
			btn.on("click",function(){
				// 1 隐藏此按钮
				// 2 之前已经加载过的 后台再次加载一边大图 没有加载过的图片 滑动加载时 直接加载大图
				btn.remove();
				var smallImgNotLoad = $(".img-box.small");
				var allImgs = $(".img-box");
				for(var i = 0; i < allImgs.length; i++){
					$(allImgs[i]).data("mode","big");
				}
				var preLoads = [];
				for(var i = 0; i < smallImgNotLoad.length; i++){
					preLoads.push($(smallImgNotLoad[i]).data("key"));
				}
				load(preLoads);
			})
		}
	}

	function checkOriginTagAndSub(){
		if(isOriginSub == "-1"){
			return;
		}
		var plat = util.getUA();

		/*原创标签 可点击*/
		var originTags = ["一只耳","耶喽黄","不撸斯","菜菜","窜天猴","精灵","罗德先生","等灯灯","劫风","唔哩君","唔哩菌","大婊哥"];
		var origin = $(".origin").text();
		$(".source-info").addClass("originality");
		$(".source-info .portrait img").attr("src", originSubPortrait);
		if(originTags.indexOf(origin) > -1){
			$(".originality-trans").show().find("a").text(origin);
		}
		$(".originality .portrait, .originality .origin, .originality-trans a").on("click",function(){
			// 调用native注册的方法 
			if(plat == "ios"){
				WebViewJavascriptBridge.callHandler("receiveJavaScriptHandler",{
					action: 6,
					name: "tagOrigin",
					data: {
						name: origin
					} 
				},function(response){
					//alert(response);
				})
			}
			if(plat == "android"){
				newslistner.tagOrigin(origin);
			}
		})
		/*源订阅*/
		checkOriginSub();
		var originSubBtn = $(".subscribe");
		originSubBtn.on("click",function(){
			// 调用native注册的方法 
			if(plat == "ios"){
				WebViewJavascriptBridge.callHandler("receiveJavaScriptHandler",{
					action: 7,
					name: "tagSubscribe"
				},function(response){
					//alert(response);
				})
			}
			if(plat == "android"){
				newslistner.tagSubscribe();
			}
		})
	}
	/*源订阅*/
	function checkOriginSub(isSub){
		if(typeof isSub != "undefined"){
			isOriginSub = isSub.toString();
		}
		var plat = util.getUA();
		var originSubBtn = $(".subscribe");
		if(isOriginSub == "1"){
			originSubBtn.addClass(originSubOption["1"].css).text(originSubOption[1].text).show();
		}else if(isOriginSub == "0"){
			originSubBtn.addClass(originSubOption["0"].css).removeClass("ed").text(originSubOption[0].text).show();
		}else{
			// -1 不可订阅
		}
	}
	window.checkOriginSub = checkOriginSub;
	/**
	 * [set comment count invoke by app]
	 */
	function setCommentCount(count){
		if(count && count != "0"){
			$(".commentCount").text(count);
		}else{
			$(".comment-count").text("");
		}
	}
	window.setCommentCount = setCommentCount;
	/**
	 * [resize font size invoke by app]
	 */
	function resizeFontSize(size,response){
		switch(size){
			case 0 : $(".content").removeClass("fs-md").removeClass("fs-lg").addClass("fs-sm"); return;
			case 1 : $(".content").removeClass("fs-sm").removeClass("fs-lg").addClass("fs-md"); return;
			case 2 : $(".content").removeClass("fs-sm").removeClass("fs-md").addClass("fs-lg"); return;
			default: $(".content").removeClass("fs-sm").removeClass("fs-lg").addClass("fs-md"); return;
		}
	}
	window.resizeFontSize = resizeFontSize;
	/**
	 * [setNightMode ]
	 * @param {[type]} type [0:正常模式，1:夜间模式]
	 */
	function setNightMode(type){
		if(type && type == 1){
			$("body").addClass("nightMode");
		}else{
			$("body").removeClass("nightMode");
		}
	}
	window.setNightMode = setNightMode;
	/**
	 * [init data invoke by app
	 * 	
	 * ]
	 */
	function initLoadData(data){
		/**
		 * ios data 是json，需要解析，android data为解析好的对象
		 */
		if(typeof data == "string"){
			data = JSON.parse(data);
		}
		net = data.net; 
		
		isFlowSave = data.isFlowSave;

		imageList = window.imageList = data.imageList || [];
		/**
		 * 图片滑动时异步加载
		 */
		var imgLoadManager = window.imgLoadManager = new InitImgLoad(window.imageList);
		window.imgScrollLoad = imgLoadManager.scroll;
		window.initPosition = imgLoadManager.init;
		/**
		 * 检测来源是否是原创 & 源订阅状态以及是否可订阅
		 */
		isOriginSub = data.isOriginSub;
		originSubPortrait = data.originSubPortrait;
		checkOriginTagAndSub();
		/**
		 * 视频管理 forAndroid
		 */
		var ua = util.getUA();
		if(ua == "android"){
			var videoManager = new VideoManager();
			window.pauseVideo = function(){
				videoManager.pause();
			}
			window.stopVideo = function(){
				videoManager.load();
			}
		}
	}
	window.initLoadData = initLoadData;
	
	/**
	 * [connectWebViewJavascriptBridge， ios js 与 native 交互的桥梁]
	 * @param  {Function} callback [description]
	 */
	function connectWebViewJavascriptBridge(callback) {
        if (window.WebViewJavascriptBridge) { 
        	return callback(WebViewJavascriptBridge); 
        }
        if (window.WVJBCallbacks) { 
        	return window.WVJBCallbacks.push(callback); 
        }
        window.WVJBCallbacks = [callback];
        var WVJBIframe = document.createElement('iframe');
        WVJBIframe.style.display = 'none';
        WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
        document.documentElement.appendChild(WVJBIframe);
        setTimeout(function() { 
        	document.documentElement.removeChild(WVJBIframe) 
        }, 0)
	}

	function vm(){
		this.title = "";
		this.origin = "";
		this.pubtime = "";
		this.content = "";
	}
	vm.prototype = {
		setTitle: function(d){
			$(".title").html(d);
		},
		setOrigin: function(d){
			$(".origin").html(d);
		},
		setPubtime: function(d){
			$(".pubtime").html(d);
		},
		setContent: function(d){
			$(".content").html(d);
		},
		checkOriginTagAndSub: checkOriginTagAndSub
	}
	vm.prototype.render = function (data) {
		imageList = data.newsImageInfoList;
		videoList = data.newsVideoInfoList;
		this.setTitle(this.title = data.title);
		this.setOrigin(this. origin = data.source || "溜达资讯");
		this.setPubtime(this.pubtime = util.getFormatTime(data.publishTime));
		this.setContent(this.content = rebuildContent(data.content,imageList,videoList));
		if(data.newsImageInfoList && data.newsImageInfoList.length){
	    	window.imgLoadManager = new InitImgLoad(data.newsImageInfoList);
	    }
	    this.checkOriginTagAndSub();
	    if(data.newsVideoInfoList && data.newsVideoInfoList.length){
	    	window.videoManager = new VideoManager();
	    }
	}

	function Page(){
		this.vm = new vm();
		this.init();
	}

	Page.prototype = {
		init: function(){
			var plat = util.getUA();
          	if (plat == 'ios'){
              	this.initIOS();
          	}
			this.initData();
			this.bindEvent();
		},
		bindEvent: function(){
			var Self = this,
				plat = util.getUA();
			$('.share-icon-list-app li').on("click",{Self: Self},function(){
				// 调用native注册的方法 
				var type = $(this).data("type");
				if(plat == "ios"){
					WebViewJavascriptBridge.callHandler("receiveJavaScriptHandler",{
						action: 2,
						name: "tapShare",
						data: {
							platform: type,
							name: SHAREMAPPER[type]
						} 
					},function(response){
						//alert(response);
					})
				}
				if(plat == "android"){
					newslistner.share(type);
				}
				if(!plat){
					alert("您的手机暂不支持分享");
				}
			})
			$('.playBtn').on("click",function(){
				
			})
			$(".portrait img").on("error",function(e){
				$(this).attr("src", defaultOriginSubPortrait);
			})
			$('.bug-report').on("click",{Self: Self},function(){
				if(plat == "ios"){
					WebViewJavascriptBridge.callHandler("receiveJavaScriptHandler",{
						action: 3,
						name: "tapReport"
					},function(response){
						
					})
				}else if(plat == "android"){
					newslistner.report();
				}else{
					return;
				}
			})
			$('.browse-origin').on("click",{Self: Self},function(){
				if(plat == "ios"){
					WebViewJavascriptBridge.callHandler("receiveJavaScriptHandler",{
						action: 4,
						name: "tapOrigin"
					},function(response){
						
					})
				}else if(plat == "android"){
					newslistner.origin();
				}else{
					return;
				}
			})
			$('.content').on("click",function(e){
				var el = e.target,
					nodeName = el.nodeName,
					nodeType = el.nodeType,
					className = el.className;
				var index = $(el).parents(".img-box").data("index") || 0;
				var canBig = $(el).parents(".img-box").data("canBig");
				if(!nodeName || nodeType != 1){
					return;
				}
				if(nodeName.toLowerCase() == "img"){
					// 如果是小图模式 点击 首先加载大图
					if(canBig == "0"){
						return;
					}else{
						// 调用native注册的方法，查看一张图片
						if(plat == "ios"){
							WebViewJavascriptBridge.callHandler("receiveJavaScriptHandler",{
								action: 1,
								name: "tapImage",
								data: {
									index: index
								}
							},function(response){
								
							})
						}else if(plat == "android"){
							imagelistner.openImage(index);
						}else{
							//...
						}
					}
				}else if(className && className.indexOf("showBigImg") > -1){ // 点击显示全部大图按钮
					return;
				}else if(className && className.indexOf("playBtn") > -1){ // 点击播放按钮
					if(net == 0 && isFlowSave == 1 && canBig == 0){
						// 这里return ，imgLoadManager中相应点击事件
						return; 
					}
					var imgBox = $(el).parents(".img-box");
						imgBox.find("img").css({'z-index':0});
						$(el).removeClass("playBtn").addClass("loading");
					var key = imgBox.data("key");
					var img = new Image();
					img.src = util.findKey(imageList,"key="+key).src;
					img.onload = function(){
						imgBox.find("img").attr("src",img.src);
						$(el).hide();
					}
				}else{
					if(plat == "ios"){
						WebViewJavascriptBridge.callHandler("receiveJavaScriptHandler",{
							action: 5,
							name: "tapTitleBar"
						},function(response){
							
						})
					}else if(plat == "android"){
						imagelistner.hideTopBar();
					}else{
						return;
					}	
				}
			})
			$(".comment-icon").on("click",function(e){
				// android bind a click event
				if(plat == "android"){
					e.preventDefault();
					imagelistner.jumpToComment();
				}else{
					return;
				}
			})
			document.body.addEventListener('touchstart', function () { }); 
			$(".content a").on('click', function (e) { e.preventDefault(); }); 
		},
		initIOS: function(){
		    connectWebViewJavascriptBridge(function(bridge) {
		        bridge.registerHandler("resizeFontSize",resizeFontSize);
		        bridge.registerHandler("initLoadData",initLoadData);
		        bridge.registerHandler("setCommentCount",setCommentCount);
		        bridge.registerHandler("setNightMode",setNightMode);
		        bridge.registerHandler("checkOriginSub",checkOriginSub);
		    })
		},
		initData: function(){
			var preview = util.getUrlParam().preview;
			var isActivity = util.getUrlParam().activity;
			/**
			 * [客户端内不会有preview这个属性，所以执行下一步直接终止，此处是为cms预览做的]
			 * @param  {[type]} !preview [description]
			 * @return {[type]}          [description]
			 */
			if(!preview){
				return;
			}
			if(isActivity){
				$(".notActivity").hide();
			}
			var srcDisplay = util.getUrlParam().srcDisplay;
			if(srcDisplay && srcDisplay == "true"){
				var srcLink = util.getUrlParam().srcLink ? decodeURI(util.getUrlParam().srcLink) : "";
				if(srcLink != ""){
					location.href = srcLink;
				}else{
					alert("源站链接为空");
					return;				
				}
			}else{
				var Self = this,
					newsId = util.getUrlParam().newsId,
					parentType = 'CHANNEL',
					parentId = '31',
					newsType = "NEWS";
				if(newsId && newsId != ""){
					/**
					 * ajax to fetch data
					 */
					$.ajax({
						type: "get",
						url: "/v1/news/detail",
						data: {
							newsId: newsId,
							newsType: newsType,
							parentType: parentType,
							parentId: parentId,
							filter: false
						},
						success: function(data){
							if(data.code == "10000"){
								var data = data.data;
								Self.vm.render(data);
							}else{
								console.log(data);
								alert("获取新闻详情失败");
							}
						},
						dataType: "json"
					})	
				}else{
					alert("不存在的新闻");
				}
			}
		}
	}
	var page = new Page();

	function VideoManager(){
		this.currentVideo;
		this.currentVideoBox;
		this.videos = {};
		this.scan = function(){
			var videoAll = $("video");
			for(var i = 0; i < videoAll.length; i++){
				var key = $(videoAll[i]).parent().data("key");
				$(videoAll[i]).prev().addClass("forAndroid");
				this.videos[key] = videoAll[i];
				videoEventBind(this.videos[key]);
			}
		}
		this.scan();
		this.bindEvent = function(){
			var that = this;
			$(".video-box").on("click",function(){
				if(that.currentVideo){
					that.currentVideo.pause();
				}
				that.currentVideo = $(this).find("video")[0];
				that.currentVideoBox = this;
				that.currentVideo.play();
			})
			var videoEventBind = function(video){
				$(video).on("play", function(){
					$(videoAll[i]).parent().addClass("playing");
					$(that.currentVideo).attr("controls",true);
				})
				$(video).on("pause ended", function(){
					$(videoAll[i]).parent().removeClass("playing");
					$(that.currentVideo).removeAttr("controls");
				})
			}
		}
		this.bindEvent();
		this.play = function(){
			this.currentVideo && this.currentVideo.play();
		}
		this.pause = function(){
			this.currentVideo && this.currentVideo.pause();
		}
		this.stop = function(){
			this.currentVideo && this.currentVideo.load();
		}
		this.getVideo = function(){
			return this.currentVideo;
		}
	}
	
}())